<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable
                class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search"
                class="filter-item">搜索
            </el-button>
            <el-button @click="addRow" type="primary" icon="el-icon-plus"
                class="filter-item">添加
            </el-button>
            <el-button @click="download" type="primary" icon="el-icon-download"
                :loading="downloading" class="filter-item">导出EXCEL
            </el-button>
        </div>
        <el-table :data="tableData" row-key="id" ref="table"
            height="tableHeight" header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row" cell-class-name="table-cell">
            <el-table-column v-if="multipleMode" align="center" type="selection"
                width="50">
            </el-table-column>
            <el-table-column prop="id" label="ID" width="100">
                <template slot="header" slot-scope="{column}">
                    <sortable-header :column="column" :current-sort="sort"
                        @changeSort="changeSort">
                    </sortable-header>
                </template>
            </el-table-column>
            <el-table-column prop="username" label="用户名" min-width="300">
                <template slot="header" slot-scope="{column}">
                    <sortable-header :column="column" :current-sort="sort"
                        @changeSort="changeSort">
                    </sortable-header>
                </template>
            </el-table-column>
            <el-table-column prop="nickname" label="昵称" min-width="300">
            </el-table-column>
            <el-table-column label="头像" min-width="300">
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                        :src="row.avatar" fit="cover"
                        :preview-src-list="[row.avatar]"></el-image>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" fixed="right">
                <template slot-scope="{row}">
                    <el-button @click="editRow(row)" type="primary" size="mini"
                        plain>编辑</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode"
                    @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div>
            <el-pagination background @size-change="onSizeChange"
                @current-change="onCurrentChange" :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements">
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from "vuex";
import pageableTable from "@/mixins/pageableTable";

export default {
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: "",
            url: "/user/all",
            downloading: false
        };
    },
    computed: {
        ...mapState([]),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            if (this.search) {
                return { search: this.search };
            }
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: "/userEdit",
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: "/userEdit",
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get("/user/excel", { responseType: "blob" })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(
                        new Blob([res.data])
                    );
                    const link = document.createElement("a");
                    link.href = downloadUrl;
                    link.setAttribute(
                        "download",
                        res.headers["content-disposition"].split("filename=")[1]
                    );
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: "提示",
                message: this.selection
            });
        },
        operation2() {
            this.$message("操作2");
        }
    }
};
</script>
<style lang="less" scoped>
</style>
